import { Component, createSignal } from 'solid-js';

import styles from './Page.module.css';
import { JSX } from 'solid-js';
import Navigation from '../Navigation';

function copy(field: HTMLInputElement) {
	field.select();
	document.execCommand('copy');
}

const StrLen: Component = () => {
	const [output, setOutput] = createSignal(0);
	const [outputWords, setOutputWords] = createSignal(0);

	const onChange: JSX.EventHandler<HTMLTextAreaElement, InputEvent> = (event) => {
		setOutput(event.currentTarget.value.length);
		setOutputWords(event.currentTarget.value.split(' ').filter(i => i != '').length);
	};

	let outputField: HTMLInputElement | undefined;
	let outputWordsField: HTMLInputElement | undefined;

	return (
		<div class={styles.page}>
			<h1>String Length</h1>
			<h2>Input</h2>
			<textarea oninput={onChange} />
			<h2>Output</h2>
			<h3>Length</h3>
			<input value={output()} ref={outputField} />
			<button onclick={() => copy(outputField!)}>Copy Output</button>
			<h3>Word Count</h3>
			<input value={outputWords()} ref={outputWordsField} />
			<button onclick={() => copy(outputWordsField!)}>Copy Output</button>
			<h2>All Tools</h2>
			<Navigation />
		</div>
	);
};

export default StrLen;
