import { Component, createSignal } from 'solid-js';

import styles from './Page.module.css';
import { JSX } from 'solid-js';
import Navigation from '../Navigation';

const StrRev: Component = () => {
	const [output, setOutput] = createSignal('');

	const onChange: JSX.EventHandler<HTMLTextAreaElement, InputEvent> = (event) => {
		setOutput(event.currentTarget.value.split('').reverse().join(''));
	};

	let outputField: HTMLInputElement | undefined;

	const copy = async () => {
		outputField!.select();
		document.execCommand('copy');
	};

	return (
		<div class={styles.page}>
			<h1>String Reverse</h1>
			<h2>Input</h2>
			<textarea oninput={onChange} />
			<h2>Output</h2>
			<input value={output()} ref={outputField} />
			<button onclick={copy}>Copy Output</button>
			<h2>All Tools</h2>
			<Navigation />
		</div>
	);
};

export default StrRev;
